#include <stdio.h>
#include <sys/stat.h>   // fuer struct stat
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

int main() {
    char buf[256];
    int fd, pos, n, i;
    struct stat statbuf;
    if ((fd = open("file-1", O_RDWR | O_CREAT | O_TRUNC, 0664)) < 0)
	perror("open"), exit(1);
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);

    if (write(fd, "0123456789", 11) != 11)	/* String schreiben */
	perror("write"), exit(2);
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position nach dem Schreiben: %d\n", pos);

    lseek(fd, -2, SEEK_SET); 		/* 2 Bytes vor den Anfang */
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position vor dem Anfang? %d\n", pos);
    
    if (write(fd, "xx", 2) != 2)		/* String schreiben */
	perror("write"), exit(2);

    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position nach dem 2. Schreiben: %d\n", pos);
    
    lseek(fd, 40, SEEK_END);		/* 40 Bytes hinter das Ende */
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position hinterm Ende? %d\n", pos);

    if (fstat(fd, &statbuf) < 0)
	   perror("stat"), exit(4);    // Abbruch im Fehlerfall
    printf("Datei-Groesse: %ld\n", statbuf.st_size);

    if (write(fd, "aa\n", 3) != 3)
	perror("write"), exit(2);
    
    pos = lseek(fd, 0, SEEK_CUR);
    printf("Position wieder nach dem Schreiben: %d\n", pos);

    if (fstat(fd, &statbuf) < 0)
	   perror("stat"), exit(5);    // Abbruch im Fehlerfall
    printf("Datei-Groesse: %ld\n", statbuf.st_size);

    lseek(fd, 0, SEEK_SET);	/* an den Anfang positionieren */
    n = read(fd, buf, 255);	/* alle (?) Zeichen lesen */
    buf[n] = '\0';		/* String mit Null-Byte terminieren */
    printf("%d Bytes gelesen:  ", n);
    puts(buf);			/* ... und schliesslich ausgeben */
    printf("einzeln:\n");
    for (i=0; i<n; i++)
          printf("%o(%c):", buf[i], buf[i]);
    printf("\n");
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);

    return 0;    
}
